EDIT - feature request #5573

Cache Strategy for Media Specimen required
02/18/2016 10:39 AM - Andreas Mdller

Status: Closed Start date:

Priority: New Due date:

Assignee: Andreas Muller % Done: 100%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.23

Severity: normal

Description

What exactly do we want to have in a generic Media Cache Strategy?

Is it possible to have a common strategy?

Discuss with users: #4585

See also #5575 and #5581

Related issues:

Related to EDIT - feature request #7612: CacheStrategy for MediaSpecimens Duplicate
Related to EDIT - feature request #4363: Show more informative message for un... Closed
Related to EDIT - task #9594: Use MediaSpecimen as input for MediaSpecimenGen... Closed
Related to EDIT - feature request #5952: Second cache field for specimen (ide... Closed
Related to EDIT - feature request #9597: Improve formatting of MediaSpecimen ... Closed
Related to EDIT - task #9678: Remove Derived- and FieldUnitFacadeCacheStrategies Closed
Related to EDIT - feature request #5575: DNA Sample requires CacheStrategy Closed
Related to EDIT - bug #5581: Specimen title cache does not show up correctly ... Closed
Related to EDIT - bug #9978: Change of CacheStrategy from DerivedUnitFacade t... In Progress
Has duplicate EDIT - feature request #7612: CacheStrategy for MediaSpecimens Duplicate

Associated revisions

Revision 19729558 - 01/09/2021 01:30 AM - Andreas Miiller

ref #7612 a first (preliminary) version of MediaSpecimenDefaultCacheStrategy

Revision 26008f31 - 01/09/2021 11:22 AM - Andreas Miiller
ref #5573, ref #7612 adapt MediaSpecimenDefaultCacheStrategy to OccurrenceCacheStrategyBase

Revision d0cd78c9 - 04/28/2021 05:06 PM - Andreas Miiller

ref #7612, ref #5573 adapt MediaSpecimenDefaultCacheStrategy to show file name only if no other information exists

Revision 9aa30fc8 - 04/28/2021 07:07 PM - Andreas Miiller
ref #1602, ref #5573, ref #7612 Include artist in MediaDefaultCacheStrategy

Revision 1cd6de7e - 04/29/2021 05:00 PM - Andreas Miiller
ref #9594 | ref #5573, ref #7612 use MediaSpecimenCacheStrategy in DerivateLabelProvider

Revision 957e3207 - 04/30/2021 07:15 AM - Andreas Miiller
ref #5573, ref #7612 some doc

Revision e651eaf3 - 04/30/2021 09:26 AM - Andreas Miiller

ref #7612, ref #5573, ref #5575 use mostSignificantldentifier instead of accession number only
Revision 0cc955fe - 05/12/2021 02:47 PM - Andreas Miiller
ref #5573 minor changes to MediaSpecimenDefaultCacheStrategy Test

Revision 155b3863 - 05/19/2021 11:50 AM - Katja Luther
ref #5573: adapt test

Revision 10ab27cc - 05/19/2021 03:29 PM - Andreas Miiller
ref #9632, ref #5573 fix titteCache update in Media with workaround (not aspectj yet)

Revision 01d32cbd - 05/19/2021 05:10 PM - Andreas Miiller
ref #9632, ref #5573 fix titteCache update in Media with workaround (not aspectj yet) (cont.)

Revision 7357605f - 05/20/2021 01:17 PM - Katja Luther

ref #5573: setMedia for media changes in MediaSpecimenDetailElement

Revision 784{80e6 - 05/20/2021 02:37 PM - Katja Luther

ref #5573: reset titleCache for setMedia in mediaSpecimen

Revision eb34070d - 05/21/2021 11:43 AM - Katja Luther

ref #5573: call resetTitleCache after changing media

Revision 53d2daf2 - 05/21/2021 11:45 AM - Katja Luther

ref #5573: remove resetTitleCache in setMedia()

History

#1 - 01/09/2021 10:21 AM - Andreas Miiller
- Related to feature request #7612: CacheStrategy for MediaSpecimens added

#2 - 01/09/2021 11:24 AM - Andreas Miiller

- Description updated

- Target version changed from Unassigned CDM tickets to Release 5.19
- % Done changed from 0 to 20

- Private changed from Yes to No

#3 - 01/27/2021 03:43 PM - Andreas Miiller

- Target version changed from Release 5.19 to Release 5.21

#4 - 03/10/2021 02:35 PM - Andreas Miiller

- Target version changed from Release 5.21 to Release 5.22

#5 - 04/16/2021 10:13 PM - Andreas Miiller

- Status changed from New to Resolved

#6 - 04/29/2021 02:39 PM - Andreas Miiller

- Related to feature request #4363: Show more informative message for unsupported specimen structures in specimen bulk editor added

#7 - 04/29/2021 04:19 PM - Andreas Miiller
- Related to task #9594: Use MediaSpecimen as input for MediaSpecimenGeneralDetailElement added

#8 - 04/29/2021 04:22 PM - Andreas Miiller

- Target version changed from Release 5.22 to Release 5.25

To use the new cache strategy the editor needs to be refactored a bit: #9594

#9 - 04/29/2021 04:29 PM - Andreas Miiller
- % Done changed from 20 to 50
A first version is implemented now. This cache strategy differs from default derived unit cache strategies in the way that it does not include any field
unit data. Only the media and accession data are included.
Maybe in future this will be unified once the second cache field for specimen is fully supported (#5952)

#10 - 04/29/2021 04:30 PM - Andreas Miiller
- Related to feature request #5952: Second cache field for specimen (identityCache) added

#11 - 04/30/2021 08:25 PM - Andreas Miiller

- Related to feature request #9597: Improve formatting of MediaSpecimen in TypeDesignationWorkingSet formatting added

#12 - 04/30/2021 08:27 PM - Andreas Miiller

- Description updated

An iconotyp may have completely different requirements than a scan that is derived from a preserved specimen.

MediaSpecimen being type designations are handled in #9597.

#13 - 04/30/2021 08:27 PM - Andreas Miiller

- Description updated

#14 - 04/30/2021 10:26 PM - Andreas Miiller

- Assignee changed from Andreas Muiller to Katja Luther

| think this is fully implemented now. If users want it differently they may tell us by time and we can adapt the code if necessary.
Please review who ever wants to review.

#15 - 05/12/2021 02:20 PM - Katja Luther

- Status changed from Resolved to Feedback

- Assignee changed from Katja Luther to Andreas Kohlbecker

Shouldn't the motif be part of the titlecache if no other field is filled?
At the moment the titleCache is the UUID if a motif exist but nothing else. But maybe AK want do a review as well?

#16 - 05/12/2021 02:51 PM - Andreas Miiller
- Assignee changed from Andreas Kohlbecker to Katja Luther
Katja Luther wrote:
Shouldn't the motif be part of the titlecache if no other field is filled?
At the moment the titleCache is the UUID if a motif exist but nothing else. But maybe AK want do a review as well?
| don't think that this is a problem of the cache strategy. It shows motif as you expected as you can see the according test

MediaSpecimenDefaultCacheStrategy Test.test().

But | can see that in the specimen tree editor the cache is not correctly updated so my guess is that there is an issue in the taxeditor, maybe related
to #9594. Katja, can you check this.

#17 - 05/17/2021 01:30 PM - Andreas Miiller

- Target version changed from Release 5.25 to Release 5.23
#18 - 05/18/2021 11:52 AM - Katja Luther
Andreas Miller wrote:

Katja Luther wrote:

Shouldn't the motif be part of the titlecache if no other field is filled?
At the moment the titleCache is the UUID if a motif exist but nothing else. But maybe AK want do a review as well?
| don't think that this is a problem of the cache strategy. It shows motif as you expected as you can see the according test
MediaSpecimenDefaultCacheStrategy Test.test().

But | can see that in the specimen tree editor the cache is not correctly updated so my guess is that there is an issue in the taxeditor, maybe

related to #9594. Katja, can you check this.

The motif problem is a cache problem, | expand the test and added a test for only change the motif and the titeCache does not change. Changing the
motif and the artist results in an updated titleCache.

#19 - 05/18/2021 01:15 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Miiller

#20 - 05/19/2021 05:38 PM - Andreas Miiller

- Assignee changed from Andreas Mtiller to Katja Luther

The failing test is fixed now (titteCache is set to null and a property change event is thrown). However, as the event is thrown by Media not by
MediaSpecimen it is maybe not yet catched by the taxeditor Ul. This also is the case when changing the artist, not only motif. When changing the
value in TaxEd nothing changes in the tree or elsewhere.

#21 - 05/20/2021 11:35 AM - Katja Luther
- Assignee changed from Katja Luther to Andreas Mdiller
Andreas Muller wrote:
The failing test is fixed now (titteCache is set to null and a property change event is thrown). However, as the event is thrown by Media not by

MediaSpecimen it is maybe not yet catched by the taxeditor Ul. This also is the case when changing the artist, not only motif. When changing
the value in TaxEd nothing changes in the tree or elsewhere.

But the titleCache is not really updated, only the cache strategy works as expected. Calling specimen.getTitleCache() results in a wrong result, but the
titteCache of the media is updated.

#22 - 05/20/2021 12:07 PM - Andreas Miiller
Katja Luther wrote:
Andreas Muller wrote:
The failing test is fixed now (titteCache is set to null and a property change event is thrown). However, as the event is thrown by Media not

by MediaSpecimen it is maybe not yet catched by the taxeditor Ul. This also is the case when changing the artist, not only motif. When
changing the value in TaxEd nothing changes in the tree or elsewhere.

But the titleCache is not really updated, only the cache strategy works as expected. Calling specimen.getTitleCache() results in a wrong result,
but the titleCache of the media is updated.

That is want | meant above. So my question was if we can not catch the media property change event additional to the mediaSpecimen event. Also
throwing a media specimen event is probably possible but tricky as it is not so easy to register the media event for the media specimen event in case
the media is loaded by hibernate. Therefor a work around like the above would be helpful for now.

#23 - 05/20/2021 03:04 PM - Katja Luther
Andreas Miller wrote:
Katja Luther wrote:
Andreas Miiller wrote:
The failing test is fixed now (titteCache is set to null and a property change event is thrown). However, as the event is thrown by Media

not by MediaSpecimen it is maybe not yet catched by the taxeditor Ul. This also is the case when changing the artist, not only motif.
When changing the value in TaxEd nothing changes in the tree or elsewhere.

But the titleCache is not really updated, only the cache strategy works as expected. Calling specimen.getTitleCache() results in a wrong
result, but the titleCache of the media is updated.

That is want | meant above. So my question was if we can not catch the media property change event additional to the mediaSpecimen event.
Also throwing a media specimen event is probably possible but tricky as it is not so easy to register the media event for the media specimen
event in case the media is loaded by hibernate. Therefor a work around like the above would be helpful for now.

Implemented a workaround with resetting the titlecache when setting the media object in mediaspecimen and on editor side setting the media for
every media change in details view

#24 - 05/20/2021 03:09 PM - Katja Luther
- Status changed from Feedback to Closed

tested the workaround on nightly and it worked as expected.

#25 - 05/20/2021 03:12 PM - Andreas Miiller
- % Done changed from 50 to 100

#26 - 06/25/2021 10:36 AM - Andreas Miiller
- Related to task #9678: Remove Derived- and FieldUnitFacadeCacheStrategies added

#27 - 03/11/2022 05:51 PM - Andreas Miiller
- Has duplicate feature request #7612: CacheStrategy for MediaSpecimens added

#29 - 03/11/2022 05:53 PM - Andreas Miiller
- Related to feature request #5575: DNA Sample requires CacheStrategy added
- Related to bug #5581: Specimen title cache does not show up correctly after editing added

#30 - 03/14/2022 09:40 AM - Katja Luther

- Related to bug #9978: Change of CacheStrategy from DerivedUnitFacade to DerivedUnitDefaultCacheStrategy results in different caches for
MediaSpecimen added
